Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.

Bug 1913438

Summary: python-pandas fails to build with GCC 11: error: array subscript ‘struct PyMethodObject[0]’ is partly outside array bounds of ‘struct PyObject[1]’ [-Werror=array-bounds]
Product: [Fedora] Fedora Reporter: Miro Hrončok <mhroncok>
Component: python-pandasAssignee: kushaldas@gmail.com <mail>
Status: CLOSED RAWHIDE QA Contact:
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: rawhideCC: blentz, mail, mhroncok, orion, sergio.pasra, thrnciar, tomspur
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2021-01-24 19:38:24 UTC Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On:    
Bug Blocks: 1868278, 1890881    

Description Miro Hrončok 2021-01-06 18:45:01 UTC
python-pandas fails to build with Python 3.10.0a4 and with Python 3.9.1:

gcc -pthread -Wno-unused-result -Wsign-compare -DDYNAMIC_ANNOTATIONS_ENABLED=1 -DNDEBUG -O2 -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong -m64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -D_GNU_SOURCE -fPIC -fwrapv -O2 -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong -m64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -D_GNU_SOURCE -fPIC -fwrapv -O2 -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong -m64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -D_GNU_SOURCE -fPIC -fwrapv -O2 -flto=auto -ffat-lto-objects -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -fstack-protector-strong -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1 -m64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -fPIC -DNPY_NO_DEPRECATED_API=0 -Ipandas/_libs/tslibs -Ipandas/_libs/src/klib -I/usr/lib64/python3.10/site-packages/numpy/core/include -I/usr/include/python3.10 -c pandas/_libs/tslibs/parsing.c -o build/temp.linux-x86_64-3.10/pandas/_libs/tslibs/parsing.o -Werror
pandas/_libs/tslibs/parsing.c: In function ‘__pyx_f_6pandas_5_libs_6tslibs_7parsing_dateutil_parse.constprop.0’:
pandas/_libs/tslibs/parsing.c:8989:22: error: array subscript ‘struct PyMethodObject[0]’ is partly outside array bounds of ‘struct PyObject[1]’ [-Werror=array-bounds]
 8989 |           __pyx_t_10 = PyMethod_GET_SELF(__pyx_t_2);
In file included from /usr/include/python3.10/pytime.h:6,
                 from /usr/include/python3.10/Python.h:85,
                 from pandas/_libs/tslibs/parsing.c:42:
/usr/include/python3.10/object.h:559:22: note: while referencing ‘_Py_NoneStruct’
  559 | PyAPI_DATA(PyObject) _Py_NoneStruct; /* Don't use this directly */
      |                      ^~~~~~~~~~~~~~
pandas/_libs/tslibs/parsing.c:8991:23: error: array subscript ‘struct PyMethodObject[0]’ is partly outside array bounds of ‘struct PyObject[1]’ [-Werror=array-bounds]
 8991 |             PyObject* function = PyMethod_GET_FUNCTION(__pyx_t_2);
      |                       ^~~~~~~~
In file included from /usr/include/python3.10/pytime.h:6,
                 from /usr/include/python3.10/Python.h:85,
                 from pandas/_libs/tslibs/parsing.c:42:
/usr/include/python3.10/object.h:559:22: note: while referencing ‘_Py_NoneStruct’
  559 | PyAPI_DATA(PyObject) _Py_NoneStruct; /* Don't use this directly */
      |                      ^~~~~~~~~~~~~~
cc1: all warnings being treated as errors


FWIW this might be a Cython or a gcc issue.


For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01865197-python-pandas/

For all our attempts to build python-pandas with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/python-pandas/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.


Koschei failures: https://koschei.fedoraproject.org/package/python-pandas?collection=f34

Comment 1 Fedora Release Engineering 2021-01-24 04:22:29 UTC
Dear Maintainer,

your package has an open Fails To Build From Source bug for Fedora 34.
Action is required from you.

If you can fix your package to build, perform a build in koji, and either create
an update in bodhi, or close this bug without creating an update, if updating is
not appropriate [1]. If you are working on a fix, set the status to ASSIGNED to
acknowledge this. If you have already fixed this issue, please close this Bugzilla report.

Following the policy for such packages [2], your package will be orphaned if
this bug remains in NEW state more than 8 weeks (not sooner than 2021-03-03).

A week before the mass branching of Fedora 35 according to the schedule [3],
any packages not successfully rebuilt at least on Fedora 33 will be
retired regardless of the status of this bug.

[1] https://docs.fedoraproject.org/en-US/fesco/Updates_Policy/
[2] https://docs.fedoraproject.org/en-US/fesco/Fails_to_build_from_source_Fails_to_install/
[3] https://fedorapeople.org/groups/schedule/f-35/f-35-key-tasks.html

Comment 2 Orion Poplawski 2021-01-24 19:38:24 UTC
According to koschei, python-pandas is building again in rawhide.

Comment 3 Red Hat Bugzilla 2023-09-15 00:57:48 UTC
The needinfo request[s] on this closed bug have been removed as they have been unresolved for 500 days